﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Infragistics.Web.Mvc;
using igGrid_selectionTest_MVC5.Models;

namespace igGrid_selectionTest_MVC5.Controllers
{
    public class HomeController : Controller
    {
           //
        // GET: /Home/
        WinesList wl = new WinesList();

        public ActionResult Index()
        {   
            return View();
        }

        [GridDataSourceAction]
        public ActionResult GetGridData()
        {
            //return View(igGrid_MVC.Models.ProductsList.GetGridData());
            return View(wl.GetWineList());
        }

        public ActionResult UpdateGrid(string ig_transactions)
        {
            //postData = HttpContext.Request.Form["ig_transactions"];
            //ArrayList data = (ArrayList)Procurios.Public.JSON.JsonDecode(ig_transactions);
            GridModel m = new GridModel();

            List<Transaction<Wine>> transactions = m.LoadTransactions<Wine>(HttpContext.Request.Form["ig_transactions"]);
            ViewData["GenerateCompactJSONResponse"] = false;
            foreach (Transaction<Wine> t in transactions)
            {
                switch (t.type)
                {
                    case "row":
                        {
                            wl.UpdateWine(t.row);
                        }
                        break;
                    case "newrow":
                        {
                            wl.AddWine(t.row);
                        }
                        break;
                    case "deleterow":
                        {
                            wl.DeleteWine(Convert.ToInt32(t.rowId));
                        }
                        break;
                };
            }

            JsonResult result = new JsonResult();
            Dictionary<string, bool> response = new Dictionary<string, bool>();
            response.Add("Success", true);
            result.Data = response;
            return result;
        }




        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}

